<?php

/**
 * @file bt_torrent.admin.inc
 *   Provides the admin form for the bt_torrent node type
 */

/**
 * Admin page for setting variables for the node type
 *
 * @return The form object
 */
function bt_torrent_admin_settings() {
  if (module_exists('bt_tracker')) {
    global $base_url;
    $default_url = $base_url .'/announce.php';
  }
  else {
    $default_url = '';
  }
  
  $form['bt_announce'] = array(
    '#type' => 'fieldset',
    '#title' => t('Announce URLs'),
    '#description' => t('Control where the torrents\' URLs will point.'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['bt_announce']['bt_override_announce'] = array(
    '#type' => 'radios',
    '#title' => t('Override Announce URL'),
    '#options' => array(
      t('Leave Intact'),
      t('Append'),
      t('Override'),
    ),      
    '#default_value' => variable_get('bt_override_announce', 1),
    '#description' => t('This determines whether or not the announce URL of the torrents being uploaded should be changed. Append will simply add your URL to the torrent\'s list of announce URLs, where Override will replace the current announce URL(s)'),
  );
  $form['bt_announce']['bt_override_announce_url'] = array(
    '#type' => 'textfield',
    '#title' => t('New Announce URL'),
    '#default_value' => variable_get('bt_override_announce_url', $default_url),
    '#description' => t('This is the URL to use for the torrents being uploaded.')
  );
  
  $form['bt_cron'] = array(
    '#type' => 'fieldset',
    '#title' => t('CRON Jobs'),
    '#description' => t('Controls what CRON jobs run within this module.'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['bt_cron']['bt_scrape_cron'] = array(
    '#type' => 'radios',
    '#title' => t('Scrape other trackers'),
    '#options' => array(
      t('Do not scrape'),
      t('Scrape for statistics'),
    ),
    '#default_value' => variable_get('bt_scrape_cron', 0),
    '#description' => t('Use CURL to load the statistics for torrents that are not tracked locally.'),
  );
  $form['bt_cron']['bt_scrape_cron_interval'] = array(
    '#type' => 'textfield',
    '#title' => t('Scrape Interval'),
    '#default_value' => variable_get('bt_scrape_cron_interval', 7200),
    '#description' => t('IF enabled, how often the tracker should scrape other trackers'),
  );
  
  
  return system_settings_form($form);
}